#!/usr/bin/perl

#use diagnostics;
use warnings;
use strict;
use lib '/usr/local/esia/plugins/trap/';
use trapUtils;

if ($#ARGV == -1) {
  print "Usage : Cisco Envmon <ciscoEnvMonTemperatureStatusValue> <ciscoEnvMonTemperatureState>\n";
  exit(1);
}
#ciscoEnvMonTemperatureState
#       1: normal
#       2: warning
#       3: critical
#       4: shutdown
#       5: notPresent
#       6: notFunctioning

my $timestamp = time();

my $tempValue = $ARGV[0];
my $tempState = $ARGV[1];
my $err='none';
my $ret=0;
my $msg;
if($tempState=="1")
{
	$ret = 0;
	$msg="OK: Temperature state $tempState value $tempValue °c";
}
elsif($tempState=="2")
{
	$ret = 1;
	$msg="WARNING: Temperature state $tempState value $tempValue °c";
}
elsif($tempState=="3")
{
	$ret = 2;
	$msg="CRITICAL: Temperature state $tempState value $tempValue °c";
}
else
{
	$ret = 3;
	$msg="UNKNOWN: Temperature state $tempState value $tempValue °c";
}
print "$msg";
exit($ret);

