#!/usr/bin/perl

#use diagnostics;
use warnings;
use strict;
use DBI;
use Config::IniFiles;
use lib '/usr/local/esia/plugins/trap/';
use trapUtils;

if ($#ARGV == -1) {
  print "Usage : Errdisable <serviceid> <StatusCause:ifndex> \n";
  exit(1);
}
my $timestamp = time();

my $cfg = new Config::IniFiles( -file => "/etc/esia/esia.conf" );
my $msg="";
my $db = DBI -> connect($cfg->val( 'POSTGRESQL', 'PGSQL_connect' ),$cfg->val( 'POSTGRESQL', 'PGSQL_username' ),$cfg->val( 'POSTGRESQL', 'PGSQL_pwd' )) || die $msg="Connexion DB impossible";
my $serviceid = $ARGV[0];
my $err = $ARGV[1];
my $ifIndex;
my $cause ;
if($err =~/cErrDisableIfStatusCause\.([0-9]*)\.0:([a-zA-Z]*)/)
{
	$ifIndex=$1;
	$cause = $2;
}
elsif($err =~/\.3\.1\.1\.2\.([0-9]*)\.0:([0-9]*)/)
{
	$ifIndex=$1;
	$cause = $2;
}
elsif($err =~/\.3\.1\.1\.2\.([0-9]*):([0-9]*)/)
{
	$ifIndex=$1;
	$cause = $2;
}
else
{
	print "ERROR: variable $err not correspond";
	exit(4)
}
my %hashcause =("1"=>"udld",
"2"=>"bpduGuard",
"3"=>"channelMisconfig",
"4"=>"pagpFlap",
"5"=>"dtpFlap",
"6"=>"linkFlap",
"7"=>"l2ptGuard",
"8"=>"dot1xSecurityViolation",
"9"=>"portSecurityViolation",
"10"=>"gbicInvalid",
"11"=>"dhcpRateLimit",
"12"=>"unicastFlood",
"13"=>"vmps",
"14"=>"stormControl",
"15"=>"inlinePower",
"16"=>"arpInspection",
"17"=>"portLoopback",
"18"=>"packetBuffer",
"19"=>"macLimit",
"20"=>"linkMonitorFailure",
"21"=>"oamRemoteFailure",
"22"=>"dot1adIncompEtype",
"23"=>"dot1adIncompTunnel",
"24"=>"sfpConfigMismatch",
"25"=>"communityLimit",
"26"=>"invalidPolicy",
"27"=>"lsGroup",
"28"=>"ekey",
"29"=>"portModeFailure",
"30"=>"pppoeIaRateLimit",
"31"=>"oamRemoteCriticalEvent",
"32"=>"oamRemoteDyingGasp",
"33"=>"oamRemoteLinkFault",
"34"=>"mvrp",
"35"=>"tranceiverIncomp");
my $erre='none';
my $interfaceid;
my $deviceid;
if(defined($ifIndex))
{
	my $query = $db->prepare("SELECT interface_id,interface_critical,interface_name,device_id
				FROM esia_device 
				JOIN esia_interface ON device_id = interface_device_id
				JOIN esia_services ON device_id = service_device_id
			  	WHERE service_id = ? AND interface_ifindex=?");
	$query->execute($serviceid,$ifIndex);
	while ( (my @row = $query->fetchrow_array)) 
	{
		
		my $msg ="$hashcause{$cause} error detected on ".$row[2];
		$interfaceid = $row[0];
		$deviceid= $row[3];
		my $erreurid = trapUtils::getErrorID($db,'err_disable');
		trapUtils::InsertInterfaceError($db,$erreurid,$deviceid,$interfaceid,$serviceid,$msg,0);
		$msg.="(Err Disabled)";
	}
}
else
{
	$msg.="Trap Inconnue";
	$erre="warning";
}
$db->disconnect;
exit(4);
