#!/usr/bin/perl

#use diagnostics;
use warnings;
use strict;
use DBI;
use Config::IniFiles;
use lib '/usr/local/esia/plugins/trap/';
use trapUtils;
if ($#ARGV == -1) {
  print "Usage : Err_disable_syslogTrap <servidice > <Errname> <Errmsg> \n";
  exit(1);
}
my $timestamp = time();
my $dbmsg="";
my $err='none';
my $cfg = new Config::IniFiles( -file => "/etc/esia/esia.conf" );
my $db = DBI -> connect($cfg->val( 'POSTGRESQL', 'PGSQL_connect' ),$cfg->val( 'POSTGRESQL', 'PGSQL_username' ),$cfg->val( 'POSTGRESQL', 'PGSQL_pwd' )) || die $dbmsg="Connection DB impossible";

my $serviceid = $ARGV[0];
my $errName = $ARGV[1];
my $msg = $ARGV[2];
my $interface;
my $interfaceid='NULL';
my $deviceid;
if($msg=~/(Fa|Gi)(0\/[0-9]{1,2})/)
{
	$interface = "$1$2";
}
my $query = $db->prepare("SELECT interface_id,interface_critical,device_id
			FROM esia_device JOIN esia_interface ON device_id = interface_device_id
			JOIN esia_services ON device_id = service_device_id
			WHERE service_id = ? AND interface_name=?");
$query->execute($serviceid,$interface);
while ( (my @row = $query->fetchrow_array)) 
{
	$interfaceid = $row[0];
	$deviceid= $row[2];
	if($errName eq 'ERR_DISABLE')
	{
		my $erreurid = trapUtils::getErrorID($db,'err_disable');
		trapUtils::InsertInterfaceError($db,$erreurid,$deviceid,$interfaceid,$serviceid,$msg,0);

		$dbmsg.="$interface err-disabled";
	}
}
print $dbmsg; 
$db->disconnect;
exit(4);




