#!/usr/bin/perl

#use diagnostics;
use warnings;
use strict;
use DBI;
use Net::SNMP;
use Config::IniFiles;
use lib '/usr/local/esia/plugins/trap/';
use trapUtils;
if ($#ARGV == -1) {
#print {$interfacefile} "Usage : MacNotification:
#	octet 1    : 00 end mib
#		     01 mac learnt
#		     03 mac removed
#	octet 2-3  : Vlan ID
#	octet 4-10 : Mac addresse
#	octet 11-12: dot1dBaseport
#exemple: MacNotification_update_psql.pl '01 00 18 00 16 46 5A 83 66 00 01'\n";
					# 01 00 18 00 26 55 BD 6E 24 00 01 00 
					# 01 00 18 00 26 55 BD 6E 24 00 01 
					# 01 00 18 E0 DB 00 00 00 00 00 01 00 
 					# 02 00 18 E0 DB 00 00 00 00 00 01 
  					# 02 00 18 E0 DB 10 00 00 00 00 01 
					# 02 00 18 00 26 55 BD 6E 24 00 01 00
  exit(1);
}

my $timestamp = time();
my $cfg = new Config::IniFiles( -file => "/etc/esia/esia.conf" );
my $msg="";
my $db = DBI -> connect($cfg->val( 'POSTGRESQL', 'PGSQL_connect' ),$cfg->val( 'POSTGRESQL', 'PGSQL_username' ),$cfg->val( 'POSTGRESQL', 'PGSQL_pwd' )) || die $msg="Connexion DB impossible";

my $err='none';	
		  
my $serviceid =  $ARGV[0];
my $arg = $ARGV[1];
#Nettoyage de la chaine si nécessaire
if($arg =~/^Hex-(.*)$/)
{
	$arg=$1;
}
$arg =~ s/\s+//g;
my $i=0;
my $t;
#on récupère les infos du noeud
my $query = $db->prepare("SELECT device_id,device_snmp_community,device_ip_addr,device_snmp_version,device_snmp3_user,device_snmp3_sec_lvl,device_snmp3_auth_protocole,
				 device_snmp3_auth_key,device_snmp3_priv_protocol, device_snmp3_priv_passphrase
			  FROM esia_device 
			  JOIN esia_interface ON device_id = interface_device_id
			  JOIN esia_services ON device_id = service_device_id
			  where service_id = ?");
$query->execute($serviceid);
my @r = $query->fetchrow_array;
$query->finish();
my $interfaceid;
my $deviceid=$r[0];
my $taille=length($arg);
while($taille>0)
{
	#on sélectionne un partie de la chaine
	$t = substr($arg,22*$i,22*($i+1));
	if(!defined($t))
	{
		last;
	}
	if($t eq '00')
	{
		last;
	}
	#garde fou évite que le script parte dans une boucle infinie
	$taille=$taille-22;

	my $change = substr($t,0,2);
	my $vlanid = substr($t,2,4);
	$vlanid=hex($vlanid);
	my $mac =   substr($t,6,12);
	$mac =lc($mac);
	my $dot1d = substr($t,18,4);
	$dot1d =hex($dot1d);
	my $IP=trapUtils::dec2ip($r[2]);
	#on regarde si le VLAN est valide
	if($vlanid<4095 && $vlanid>0)
	{
		if($change==1)#Ajout de mac addresse
		{
			my $session;
			if($r[3]!='3')
			{
      				 my $community = $r[1]."@".$vlanid;	
       				$session = Net::SNMP->session (Hostname  => $IP, Community => $community, Port => 161, Retries => 1, Timeout => 3);
		      	}
		      	else
		      	{
				print "snmpv3\n".$r[4]." ".$r[5]." ".$r[6]."".$r[7];
				$session = Net::SNMP->session (Hostname  => $IP, 
						            Version => $r[3],
						            Username=>$r[4],
						            Authprotocol=>$r[6],
						            Authpassword=>$r[7], 
						            Port => 161, 
						            Retries => 2, 
						            Timeout => 3);
     			}
			#récupération du ifIndex
			my $oid=".1.3.6.1.2.1.17.1.4.1.2.$dot1d";
			my $re = $session->get_request($oid);
			if(defined ($re))
			{
				my $interface = $re->{$oid};

				$msg.="Add mac: $mac vlan: $vlanid ifindex: $interface on $IP#"; 
				#on vérifie si la mac est déjà aparue sur le réseau
				my $query_find = $db->prepare("SELECT mac FROM esia_mac WHERE mac=?");	
				$query_find->execute($mac);
				if($query_find->rows == 0) 
				{
					#si elle n'est pas apparue on l'ajoute
					my $query_insert = $db->prepare("INSERT INTO esia_mac (mac)values (?)");
					$query_insert->execute($mac);
				}
				#on selectionne l'interface
				$query = $db->prepare("SELECT interface_id FROM esia_interface WHERE interface_ifIndex=? AND interface_device_id=?");
				$query->execute($interface,$r[0]);
				while ( (my @row = $query->fetchrow_array)) 
				{
					$interfaceid = $row[0];
				}
				#on vérifie que le mac est déjà aparue ou pas sur l'interface 
				$query_find = $db->prepare("SELECT mac_address
								   FROM esia_mac_address 
								   WHERE mac_address=? AND mac_vlan_id = ? AND mac_interface_id=?");
				$query_find->execute($mac,$vlanid,$interfaceid);
				my $LOCALTIME=time();
				if( $query_find->fetch() ) 
				{
					#on remet la mac en active
					my $query_up = $db->prepare("UPDATE esia_mac_address 
								   SET mac_time_out_connection=0,mac_time_connection=?,mac_dot1dport=?
								WHERE mac_address=? AND mac_vlan_id = ? AND mac_interface_id=?");
					$query_up->execute($LOCALTIME,$dot1d,$mac,$vlanid,$interfaceid);
				}
				else
				{
					#on ajoute la mac comme active
					my $query_insert = $db->prepare("INSERT INTO esia_mac_address 
							(mac_address, mac_interface_id, mac_vlan_id, mac_time_connection,mac_time_out_connection, mac_dot1dport)
							values (?,?,?,?,0,?)");
					$query_insert->execute($mac,$interfaceid,$vlanid,$LOCALTIME,$dot1d);
				}
			}
			else
			{
				$msg="NO RESPONSE snmpget Ajout mac: $mac vlan: $vlanid dot1d:$dot1d#\n"; 
				$err="none";
			}
			$session->close();
		}
		else
		{
			if($change==2)#la mac addresse a été supprimé de la table du switch
			{
				my $LOCALTIME=time();
				my $query_up = $db->prepare("UPDATE esia_mac_address SET mac_time_out_connection=? WHERE mac_address=? AND mac_vlan_id = ? AND mac_dot1dport=?;");
				$query_up->execute($LOCALTIME,$mac,$vlanid,$dot1d);
				$msg.="Suppression mac: $mac vlan: $vlanid dot1d:$dot1d on $IP#";
			}
			else
			{
				$msg="Trap Inconnue";
				$err="warning";
			}
		}
	}
	$i++;
	
	#$t = substr($t,22,2);
	#si $t = 00 alors c'est la fin de la trap
	##print "t: $t :".33*$i.":".((33*$i)+2)."\n";
	
}
print "$msg";
$db->disconnect;
exit(4);
__END__ 
