#!/usr/bin/perl

#use diagnostics;
use warnings;
use strict;
use DBI;
use Config::IniFiles;
use lib '/usr/local/esia/plugins/trap/';
use trapUtils;

if ($#ARGV == -1) {
  print "Usage : rmon <nom_de_switch> <oid+ifindex> <value> \n";
  exit(1);
}
my $timestamp = time();
my $cfg = new Config::IniFiles( -file => "/etc/esia/esia.conf" );
my $msg="";
my $db = DBI -> connect($cfg->val( 'POSTGRESQL', 'PGSQL_connect' ),$cfg->val( 'POSTGRESQL', 'PGSQL_username' ),$cfg->val( 'POSTGRESQL', 'PGSQL_pwd' )) || die $msg="Connexion DB impossible";
my $serviceid = $ARGV[0];
my $t = $ARGV[1];
my $err='none';
my $oidname;
my $ifindex;

if($t=~/(\.1\.3\.6\.1\.2\.1\.2\.2\.1\.14)\.([0-9]*)/)	
{
		$oidname = $1;
		$ifindex=$2;	
}
else{
	if($t=~/^([a-zA-Z]*)\.([0-9]*)/)
	{
		$oidname = $1;
		$ifindex=$2;

	}
}
my $value = $ARGV[2];

my $query = $db->prepare("SELECT interface_id,interface_critical,interface_name,device_id,device_name
			  FROM esia_device 
			  JOIN esia_interface ON device_id = interface_device_id
			  JOIN esia_services ON device_id = service_device_id
			  WHERE service_id = ? AND interface_ifindex=?");
$query->execute($serviceid,$ifindex);
my $interfaceid;
my $deviceid;
while ( (my @row = $query->fetchrow_array)) 
{
	$interfaceid = $row[0];
	$deviceid=$row[3];
	if($oidname=~/ifInErrors/ || $oidname=~/1\.3\.6\.1\.2\.1\.2\.2\.1\.14/ )
	{
		my $erreurid;
		if($row[1]==1)
		{
			$erreurid = trapUtils::getErrorID($db,'critical interface input error');
		}
		else
		{
			$erreurid = trapUtils::getErrorID($db,'interface input error');
		}
		my $query_crc= $db->prepare ("SELECT happen_error_id,happen_interface_id,happen_timestamp,happen_value 
					      FROM esia_error_happen 
					      WHERE happen_error_id=? AND happen_interface_id=?  AND happen_acquitte=0 AND happen_device_id=? ;");
		$query_crc->execute($erreurid,$interfaceid,$deviceid);	
		if($query_crc->rows == 0)
		{
			my $time=time();
			my $m = "Input Error";
			trapUtils::InsertInterfaceError($db,$erreurid,$deviceid,$interfaceid,$serviceid,"Input Error",$value);
			$msg.="IfnError on ".$row[2].": ".$value;
			
		}
		else
		{
			my @r = $query_crc->fetchrow_array;
			$msg.="IfnError sur ".$row[2].":".$value."=>";
			$value=$value+$r[3];
			
			my $time=time();
			my $query_up = $db->prepare("UPDATE esia_error_happen  
						SET happen_value=?
						 WHERE happen_error_id=? AND happen_interface_id=? 
						AND happen_acquitte=0 AND happen_device_id=?;");
			$query_up->execute($value,$erreurid,$interfaceid,$deviceid);
			$msg.="$value";
		}	
	}
	else
	{
		$msg="Trap Inconnue";
		$err="warning";
	}
}
print "$msg";
$db->disconnect;
exit(4);
