#!/usr/bin/perl

#use diagnostics;
use warnings;
use strict;
use DBI;
use lib '/usr/local/esia/plugins/trap/';
use trapUtils;
use Config::IniFiles;


if ($#ARGV == -1) {
  print "Usage : linkNotification <nom_de_switch> <ifindex> <UP/DOWN> \n";
  exit(1);
}
my $timestamp = time();
#récupération fichier de configuration d'esia
my $cfg = new Config::IniFiles( -file => "/etc/esia/esia.conf");
my $msg="";
#connection à la base de données
my $db = DBI -> connect($cfg->val( 'POSTGRESQL', 'PGSQL_connect' ),$cfg->val( 'POSTGRESQL', 'PGSQL_username' ),$cfg->val( 'POSTGRESQL', 'PGSQL_pwd' )) || die $msg="Conenction DB impossible";

my $servid =  $ARGV[0];
my $interface = $ARGV[1];
my $link = $ARGV[2];
my $err='none';
#recherche de l'id de l'interface,son status (critique ou non), si up ou down, le model du switch et le nom de l'interface
my $query = $db->prepare("SELECT interface_id,interface_critical,interface_down_time,interface_name,device_id,interface_name
			  FROM esia_device 
			  JOIN esia_interface ON device_id = interface_device_id
			  JOIN esia_services ON device_id = service_device_id
			  where service_id = ? AND interface_ifIndex=?");
$query->execute($servid,$interface);
my $interfaceid;
my $deviceid;
while( (my @row = $query->fetchrow_array)) 
{
	$interfaceid = $row[0];
	$deviceid = $row[4];
	#Trap LinkUP
	if($link eq 'LinkUp')
	{
		my $query_time_down = $db->prepare("UPDATE esia_interface SET interface_down_time=0 WHERE interface_id=$interfaceid");
		$query_time_down->execute();
		$msg.=" interface $row[3] UP";	
		#si interface critique on acquitte l'erreur d'interface critique down 
		if($row[1]==1)
		{
			my $erreurid = trapUtils::getErrorID($db,'interface critical down');
			trapUtils::AcquitteInterfaceErrorByInterfaceAndErrorID($db,$interfaceid,$erreurid);
			#$msg .=" Acquitement interface critical down";
		}
		#Si l'interface était en err-disable on acquitte l'erreur
		my $erreurid = trapUtils::getErrorID($db,'err_disable');
		trapUtils::AcquitteInterfaceErrorByInterfaceAndErrorID($db,$interfaceid,$erreurid);
		my $query_err = $db->prepare("SELECT happen_id,happen_error_id,happen_interface_id,happen_timestamp 
						FROM esia_error_happen 
						WHERE happen_interface_id=? AND happen_error_id=? AND happen_acquitte=0 ");
		$query_err ->execute($interfaceid,$erreurid);
		if($query_err ->rows != 0)
		{
			my @happenid = $query_err->fetchrow_array;
			trapUtils::AcquitteInterfaceErrorByID($db,$happenid[0]);
			$msg .=" Acquitement Err-Disable";
		}
	}
	else
	{
		#Trap linkDown 
		if($link eq 'LinkDown')
		{
			#on regarde si l'interface était bien à UP
			if($row[2]==0)
			{
				#mise à jour de la base de donnée
				my $LOCALTIME=time();
				my $query_time_down = $db->prepare("UPDATE esia_interface SET interface_down_time=? WHERE interface_id=?");
				$query_time_down->execute($LOCALTIME,$interfaceid);
				$msg .=" interface $row[3] DOWN";
				#print "critical: $row[1] \n";
				# si lien critique on reporte l'alerte 
				if($row[1]==1)
				{
					my $erreurid = trapUtils::getErrorID($db,'interface critical down');
					trapUtils::InsertInterfaceError($db,$erreurid,$deviceid,$interfaceid,$servid,"critical interface down: $row[5]",0);
					$msg .=" Interface critical down";						
				}
			}
			else
			{
				$msg .=" interface $row[3] DOWN Trap raté";
			}
		}
		else
		{
			# trap reçues inconnues
			$msg="Trap Inconnue";
			$err="warning";
		}
	}
}
print $msg;
$db->disconnect;
exit(4);
__END__ 
